#!/usr/bin/env python

# example rangewidgets.py

import pygtk
pygtk.require('2.0')
import gtk
import gobject
from util import *

import fixer

MAX_WINDOW_Y_SIZE=650

def files_for_checking (files):
    files2check = []
    for f in files:
        tcs = f.type_contributors
        if len(tcs) > 1:
            tcs = ['all'] + tcs
        if f.sc_from == 'typegen':
            files2check.append([f.uid, f.name, tcs + [f.original_context]])
        else:
            files2check.append([f.uid, f.name, [f.original_context] + tcs])
    return files2check

# Convenience functions

def make_menu_item(name, callback, data=None):
    item = gtk.MenuItem(name)
    item.connect("activate", callback, data)
    item.show()
    return item

class SetFileContext:

    def done (self, the_done_button = None):
        count = 0
        for f in self.files2check:
            item = self.choices[f[0]]
            pos = item.get_active()
            fixer.set_scCB(f[1], f[2][pos], 1)
        self.window.destroy()
        files = [f for f in resources_dict.values() if f.__class__.__name__ == 'File' and \
                          len(f.type_contributors) != 0]
        files_from_envir = [f for f in files if f.sc_from != 'typegen']
        files2check = files_for_checking(files_from_envir)
        if len(files2check) != 0:
            Confirm("Confirm or Retract Type: These files may be accessed outside of this application.", \
                    files2check)
        else:
            end_session(self)

    def cb_menu_select(self, item, uid):
        fixer.set_fc(uid, str(1))

    def __init__(self, title, files2check):
        self.window = gtk.Dialog() 
        self.window.set_title(title)
	self.window.set_border_width(0)
	ysz = 1000
        nbr = len(files2check)
        if nbr < 10:
            ysz = 120 * nbr
        self.window.set_size_request(400, min(MAX_WINDOW_Y_SIZE,ysz))
	

        scrolled_window = gtk.ScrolledWindow()
	scrolled_window.set_border_width(10)
	scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)

	self.window.vbox.pack_start(scrolled_window, gtk.TRUE, gtk.TRUE, 0)
	scrolled_window.show()

        self.choices = {}
        self.files2check = files2check
        box1 = gtk.VBox(gtk.FALSE, 0)
        scrolled_window.add_with_viewport(box1)
        box1.show()

        box2 = gtk.HBox(gtk.FALSE, 10)
        self.box2 = box2
        box2.set_border_width(10)
        box1.pack_start(box2, gtk.TRUE, gtk.TRUE, 0)
        box2.show()

        #button at top
        box2 = gtk.VBox(gtk.FALSE, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, gtk.FALSE, gtk.TRUE, 0)
        box2.show()

        button = gtk.Button("Done")
        button.connect("clicked", self.done)
        box2.pack_start(button, gtk.TRUE, gtk.TRUE, 0)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        button.show()
        
        for f in files2check:
            # An option menu to select directory context
            box2 = gtk.HBox(gtk.FALSE, 10)
            box2.set_border_width(10)
            label = gtk.Label(f[1])
            box2.pack_start(label, gtk.FALSE, gtk.FALSE, 0)
            label.show()
            opt = gtk.combo_box_new_text()
            self.choices[f[0]] = opt
            options = f[2]
            count = 1
            for choice in options:
                opt.insert_text(count, choice)
                opt.set_active(0)
                count = count + 1
            box2.pack_start(opt, gtk.TRUE, gtk.TRUE, 0)
            opt.show()

            box1.pack_start(box2, gtk.TRUE, gtk.TRUE, 0)
            box2.show()

        box2 = gtk.VBox(gtk.FALSE, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, gtk.FALSE, gtk.TRUE, 0)
        box2.show()

        button = gtk.Button("Done")
        button.connect("clicked", self.done)
        box2.pack_start(button, gtk.TRUE, gtk.TRUE, 0)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        button.show()
        self.window.show()

class Confirm (SetFileContext):
     def done (self, the_done_button = None):
        count = 0
        for f in self.files2check:
            item = self.choices[f[0]]
            pos = item.get_active()
            fixer.set_scCB(f[1], f[2][pos], 1)
        self.window.destroy()
        files = [f for f in resources_dict.values() if f.__class__.__name__ == 'File' and \
                          len(f.type_contributors) != 0]
        if len(files) != 0:
             SetDirectoryContext(files)
        else:
            end_session(self)
    

def end_session (win):
    fixer.do_policy_generationCB()
    win.window.destroy()
    gtk.main_quit()
        
class SetDirectoryContext:

    def done (self, the_done_button = None):
        count = 0
        for f in self.files:
            item = self.choices[f.name]
            fixer.set_dir_scCB(f.name, self.options[item.get_active()])
        end_session(self)


    def cb_menu_select(self, item, uid):
        fixer.set_fc(uid, str(1))

    def __init__(self, files):
        self.window = gtk.Dialog() 
        self.window.set_title("Set .fc Directory Specifications")
	self.window.set_border_width(0)
	ysz = 300
        nbr = len(files)
        if nbr < 10:
            ysz = 120 * nbr
        self.window.set_size_request(400, min(MAX_WINDOW_Y_SIZE,ysz))


        scrolled_window = gtk.ScrolledWindow()
	scrolled_window.set_border_width(10)
	scrolled_window.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_ALWAYS)

	self.window.vbox.pack_start(scrolled_window, gtk.TRUE, gtk.TRUE, 0)
	scrolled_window.show()

        self.choices = {}
        self.files= files
        box1 = gtk.VBox(gtk.FALSE, 0)

        scrolled_window.add_with_viewport(box1)      
        self.options = ['dir/name.*', 'dir/name', 'dir(/.*)?', 'dir/', 'dir/.*']
        box1.show()

        box2 = gtk.HBox(gtk.FALSE, 10)
        self.box2 = box2
        box2.set_border_width(10)
        box1.pack_start(box2, gtk.TRUE, gtk.TRUE, 0)
        box2.show()

        #button at top
        box2 = gtk.VBox(gtk.FALSE, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, gtk.FALSE, gtk.TRUE, 0)
        box2.show()

        button = gtk.Button("Finish (generate te and fc files)")
        button.connect("clicked", self.done)
        box2.pack_start(button, gtk.TRUE, gtk.TRUE, 0)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        button.show()
        self.files = files
        for f in self.files:
            # An option menu to select directory context
            box2 = gtk.HBox(gtk.FALSE, 10)
            box2.set_border_width(10)
            label = gtk.Label(f.name)
            box2.pack_start(label, gtk.FALSE, gtk.FALSE, 0)
            label.show()
            opt = gtk.combo_box_new_text()
            self.choices[f.name] = opt

            count = 1
            for choice in self.options:
                opt.insert_text(count, choice)
                opt.set_active(0)
                count = count + 1
            box2.pack_start(opt, gtk.TRUE, gtk.TRUE, 0)
            opt.show()

            box1.pack_start(box2, gtk.TRUE, gtk.TRUE, 0)
            box2.show()
        box2 = gtk.VBox(gtk.FALSE, 10)
        box2.set_border_width(10)
        box1.pack_start(box2, gtk.FALSE, gtk.TRUE, 0)
        box2.show()

        button = gtk.Button("Finish (generate te and fc files)")
        button.connect("clicked", self.done)
        box2.pack_start(button, gtk.TRUE, gtk.TRUE, 0)
        button.set_flags(gtk.CAN_DEFAULT)
        button.grab_default()
        button.show()
        self.window.show()

def main():
    gtk.main()
    return 0

if __name__ == "__main__":
    Confirm('Test', [])
    main()
